## net.sf.saxon.expr
Class VariableReference

    java.lang.Object
      |
      +--net.sf.saxon.expr.ComputedExpression
            |
            +--net.sf.saxon.expr.VariableReference

All Implemented Interfaces:
  BindingReference, Container, Expression, InstructionInfoProvider, java.io.Serializable, javax.xml.transform.SourceLocator

public class VariableReference
extends ComputedExpression
implements BindingReference

Variable reference: a reference to a variable. This may be an XSLT-defined variable, a range variable defined within the XPath expression, or a variable defined in some other static context.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.ComputedExpression
`locationId, staticProperties`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`VariableReference(VariableDeclaration declaration)` Constructor

Method Summary
`Expression` `analyze(StaticContext env, ItemType contextItemType)` Type-check the expression.
`int` `computeCardinality()` Get the static cardinality
`void` `display(int level, NamePool pool, java.io.PrintStream out)` Diagnostic print of expression structure
`boolean` `equals(java.lang.Object other)` Test if this expression is the same as another expression.
`Item` `evaluateItem(XPathContext c)` Evaluate an expression as a single item.
`Value` `evaluateVariable(XPathContext c)`
`void` `fixup(Binding binding)` Fix up this variable reference to a Binding object, which enables the value of the variable to be located at run-time.
`Binding` `getBinding()` Get the object bound to the variable
`int` `getIntrinsicDependencies()` Determine the intrinsic dependencies of an expression, that is, those which are not derived from the dependencies of its subexpressions.
`ItemType` `getItemType()` Determine the data type of the expression, if possible
`int` `hashCode()` get HashCode for comparing two expressions
`SequenceIterator` `iterate(XPathContext c)` Get the value of this variable in a given context.
`Expression` `promote(PromotionOffer offer)` Promote this expression if possible
`void` `setStaticType(SequenceType type, Value value, int properties)` Set static type.
`Expression` `simplify(StaticContext env)` Simplify the expression.

Methods inherited from class net.sf.saxon.expr.ComputedExpression

`adoptChildExpression, computeDependencies, computeSpecialProperties, computeStaticProperties, dynamicError, dynamicError, effectiveBooleanValue, evaluateAsString, getCardinality, getColumnNumber, getConstructType, getDependencies, getExecutable, getImplementationMethod, getInstructionInfo, getLineNumber, getLocationId, getParentExpression, getPublicId, getSpecialProperties, getSystemId, iterateSubExpressions, markTailFunctionCalls, process, resetStaticProperties, setLocationId, setParentExpression, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### VariableReference

    public VariableReference(VariableDeclaration declaration)

  Constructor

Parameters:
  `declaration` - the variable declaration to which this variable refers

Method Detail

### simplify

    public Expression simplify(StaticContext env)

  Simplify the expression. Does nothing.

  Specified by:
    `simplify` in interface `Expression`
  Overrides:
    `simplify` in class `ComputedExpression`
  Returns:
    the simplified expression

### setStaticType

    public void setStaticType(SequenceType type,
                              Value value,
                              int properties)

  Set static type. This is a callback from the variable declaration object. As well as supplying the static type, it may also supply a compile-time value for the variable. As well as the type information, other static properties of the value are supplied: for example, whether the value is an ordered node-set.

  Specified by:
    `setStaticType` in interface `BindingReference`

### analyze

    public Expression analyze(StaticContext env,
                              ItemType contextItemType)
                       throws XPathException

  Type-check the expression. At this stage details of the static type must be known. If the variable has a compile-time value, this is substituted for the variable reference

  Specified by:
    `analyze` in interface `Expression`
  Parameters:
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
    `XPathException`

### fixup

    public void fixup(Binding binding)

  Fix up this variable reference to a Binding object, which enables the value of the variable to be located at run-time.

  Specified by:
    `fixup` in interface `BindingReference`

### getItemType

    public ItemType getItemType()

  Determine the data type of the expression, if possible

  Specified by:
    `getItemType` in interface `Expression`
  Returns:
    the type of the variable, if this can be determined statically; otherwise Type.ITEM (meaning not known in advance)

### computeCardinality

    public int computeCardinality()

  Get the static cardinality

  Specified by:
    `computeCardinality` in class `ComputedExpression`

### equals

    public boolean equals(java.lang.Object other)

  Test if this expression is the same as another expression. (Note, we only compare expressions that have the same static and dynamic context).

  Overrides:
    `equals` in class `java.lang.Object`

### hashCode

    public int hashCode()

  get HashCode for comparing two expressions

  Overrides:
    `hashCode` in class `java.lang.Object`

### getIntrinsicDependencies

    public int getIntrinsicDependencies()

  Description copied from class: `ComputedExpression`
  Determine the intrinsic dependencies of an expression, that is, those which are not derived from the dependencies of its subexpressions. For example, position() has an intrinsic dependency on the context position, while (position()+1) does not. The default implementation of the method returns 0, indicating "no dependencies".

  Overrides:
    `getIntrinsicDependencies` in class `ComputedExpression`
  Returns:
    a set of bit-significant flags identifying the "intrinsic" dependencies. The flags are documented in class net.sf.saxon.value.StaticProperty

### promote

    public Expression promote(PromotionOffer offer)
                       throws XPathException

  Promote this expression if possible

  Specified by:
    `promote` in interface `Expression`
  Overrides:
    `promote` in class `ComputedExpression`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Returns:
    if the offer is not accepted, return this expression unchanged. Otherwise return the result of rewriting the expression to promote this subexpression
  Throws:
    `XPathException` - if any error is detected

### iterate

    public SequenceIterator iterate(XPathContext c)
                             throws XPathException

  Get the value of this variable in a given context.

  Specified by:
    `iterate` in interface `Expression`
  Overrides:
    `iterate` in class `ComputedExpression`
  Parameters:
    `c` - the XPathContext which contains the relevant variable bindings
  Returns:
    the value of the variable, if it is defined
  Throws:
    `XPathException` - if the variable is undefined

### evaluateItem

    public Item evaluateItem(XPathContext c)
                      throws XPathException

  Description copied from class: `ComputedExpression`
  Evaluate an expression as a single item. This always returns either a single Item or null (denoting the empty sequence). No conversion is done. This method should not be used unless the static type of the expression is a subtype of "item" or "item?": that is, it should not be called if the expression may return a sequence. There is no guarantee that this condition will be detected.

  Specified by:
    `evaluateItem` in interface `Expression`
  Overrides:
    `evaluateItem` in class `ComputedExpression`
  Parameters:
    `c` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### evaluateVariable

    public Value evaluateVariable(XPathContext c)
                           throws XPathException

    `XPathException`

### getBinding

    public Binding getBinding()

  Get the object bound to the variable

### display

    public void display(int level,
                        NamePool pool,
                        java.io.PrintStream out)

  Diagnostic print of expression structure

  Specified by:
    `display` in interface `Expression`
  Parameters:
    `level` - indentation level for this expression
    `pool` - NamePool used to expand any names appearing in the expression
    `out` - Output destination